# 2023-080

**<h2>Automated ER Diagram Generation, Plagiarism Check, and AI-based quiz System</h2>**

* **<h3>Main Objective</h3>**

    Automated ER Diagram Generation, Plagiarism Check, and AI-based quiz System
 
* **<h3>Main Research questions</h3>**

    The real-world problem addressed by this research is the inefficiency and subjectivity of current methods used to assess student assignments that involve designing Entity-Relationship (ER) diagrams.ER diagrams are widely used in various fields such as computer science, business management, and engineering to model data and relationships between entities. Students are often required to create ER diagrams as part of their coursework or assessments. However, manually assessing these diagrams can be a time-consuming and subjective process, especially in large classes with numerous submissions.
    
    Additionally, plagiarism and improper collaboration can be major issues when assessing ER diagram assignments. It can be challenging for instructors to identify cases of plagiarism, and even if detected, it can be difficult to determine the level of collaboration involved and assign appropriate penalties. This can result in unfair outcomes for both honest and dishonest students.
    
    Furthermore, current methods of assessing ER diagrams may not accurately reflect student understanding of the material. For example, an instructor may provide a scenario and ask students to design an ER diagram and SQL queries based on that scenario. However, some students may be able to create a visually appealing diagram and query without fully understanding the underlying concepts, while others may struggle with the visual representation but have a strong grasp of the concepts.
    
    The proposed solution of an automated system that can generate ER diagrams, check for plagiarism, and suggest suitable questions for students to answer based on their ER diagrams and queries addresses these issues by providing a more efficient and objective assessment method. The system can also help instructors identify instances of plagiarism and improper collaboration more easily and accurately, while also providing students with targeted questions that reflect their level of understanding.
    
    Overall, the development of an automated ER diagram and query assessment system has the potential to improve the fairness and efficiency of assessing student assignments in various fields, while also enhancing academic integrity.


* **<h3>Individual research question</h3>**
    1.  Automated ER Diagram Generation and Query Generation
    2.  ER Diagram Analysis and Extraction
    3.  Comparison of Visual and Quantitative Similarity
    4.  Comparison of Visual and Quantitative Similarity


* **<h3>Individual Objectives</h3>**

    **1.	Automated ER Diagram Generation and Query Generation**
    
    The lengthy and challenging process of building a database schema and producing SQL queries is one of the main difficulties in the field of database management systems. It is challenging for non-technical people to develop databases and interact with them because this process necessitates a large amount of technical knowledge and skill. Even technically proficient consumers frequently find the process difficult and time-consuming. 
    
    A system that can automatically extract crucial information from natural language scenarios and produce an entity-relationship (ER) diagram, a database schema and SQL queries for the same scenario is needed to address this problem. Because there isn't a complete system in place to do this automatically yet, the procedure is still rather manual and time-consuming.
    
    The suggested approach tries to establish a system that can minimize user engagement, cut down on time spent on tasks, and still allow non-technical people to create databases and interact with them. The system will combine methods like machine learning and natural language processing (NLP) to automatically extract pertinent data from natural language scenarios and provide an ER diagram and a structured representation of the database schema. The solution will leverage the database structure and ER diagram to automatically construct SQL queries, enabling users to communicate with the database using a natural language interface. 
    
    In comparison to the present manual database design procedure, the suggested approach will provide a number of benefits. First of all, it will considerably shorten the time needed to create SQL queries and design databases. The second benefit is that it will make it less complicated and more approachable for non-technical people. The final benefit is that it will lessen mistakes and inconsistencies that could result from manual database construction. 
    
    In conclusion, a fundamental difficulty in the field of database management systems is the lack of a full system that can automatically extract relevant features from natural language scenarios and build an ER diagram, a database design, and SQL queries for the same scenario. The method being developed to address this problem seeks to reduce user engagement and time requirements while still enabling non-technical people to create databases and interact with them.
    
    **2.	ER Diagram Analysis and Extraction**
    
    After conducting a thorough analysis of the existing research in the field, it has been observed that there are several research problems that need to be addressed in the context of the proposed component. One of the primary issues is the time-consuming and difficult manual evaluation of ER diagrams in academic settings. This process is both inefficient and costly, as it requires significant resources in terms of time and personnel. Additionally, manual evaluation can also be prone to errors, leading to inaccurate evaluations and suboptimal outcomes for both students and evaluators.
    
    Another significant challenge is the high risk of plagiarism in student submissions, which can be a major impediment to fair evaluation. Existing approaches to detecting plagiarism in diagrams, including EER diagrams, have been limited in their ability to consider both shapes and text inside the shapes to analyze the conceptual ideas conveyed in the diagrams. This makes it difficult to accurately identify instances of plagiarism, leading to erroneous evaluations and unfair outcomes.
    
    Furthermore, the lack of a standardized evaluation framework for ER diagrams is another pressing research problem that needs to be addressed. This makes it difficult to compare and evaluate different submissions, as there is no consistent set of evaluation criteria that can be used across different contexts and domains.
    
    Finally, the limited availability of effective tools and resources for identifying and extracting entities, attributes, and relationships from ER diagrams is also a significant research problem. Existing tools are often insufficiently accurate or versatile and may require significant manual intervention to achieve optimal results. As a result, there is a need for more effective and efficient machine learning-based tools that can accurately identify and extract entities, attributes, and relationships from ER diagrams.
    
    Addressing these research problems can significantly enhance the accuracy and efficiency of the evaluation process for ER diagrams in academic settings, leading to fairer and more effective evaluations and better outcomes for both students and evaluators.
    
    **3.	Comparison of Visual and Quantitative Similarity**
    
    The rising worry of plagiarism in Entity-Relationship (ER) diagrams is the research topic that this study attempts to solve. This concern is especially prevalent in academic and professional settings. Although there are tools available to detect plagiarism in documents based on text, there are not currently any such tools available for ER diagrams. As a result, those educators and professionals who rely on ER diagrams to build and implement database systems have a huge hurdle as a result of this.
    
    Plagiarism in ER diagrams is not a new problem but has been one for many years and continues to be a worry. On the other hand, there are insufficient tools available to detect and prevent instances of plagiarism, which is an urgent issue that has to be addressed. ER diagrams play an important part in the process of designing and implementing databases, and it is essential that they are accurate and reliable in order to guarantee the data's authenticity and confidentiality. Plagiarism in ER diagrams can lead to the adoption of incorrect diagrams, which in turn can affect the operation and security of database management systems.
    
    Therefore, the objective of this research is to develop a plagiarism detection tool that is able to effectively detect instances of plagiarism in ER diagrams. This is the research problem that this study seeks to address. This program has to be able to recognize similarities and variations in the content as well as the visual presentation of ER diagrams, such as handwritten typefaces and the proportions of the diagrams. In addition to this, the tool needs to be precise and dependable, and its efficacy needs to be validated by testing using a comprehensive collection of ER diagrams.
    
    The resolution of this research issue is absolutely necessary in order to guarantee the precision and dependability of ER diagrams during the design and implementation of databases. Instructors and professionals will be able to detect and prevent instances of plagiarism if an efficient plagiarism detection tool for ER diagrams is developed. This will ensure that database systems continue to preserve both their integrity and their security.
    
    **4.	Comparison of Visual and Quantitative Similarity**
    
    Adapting established educational methods to the specific demands of individual pupils is one of the most difficult tasks. Although teachers try their best to provide individualized feedback, the rigors of big class numbers and scarce resources frequently leave them exhausted. There has been an increase in interest recently in creating intelligent and adaptive quiz systems that can provide students with personalized feedback and aid in their capacity for self-regulated learning (SRL).
    
    The inadequacy of conventional quiz systems has been recognized as a major obstacle in achieving this goal. These systems typically rely on multiple-choice questions or simple short-answer responses, which do not provide sufficient insight into the student's understanding of the material. This makes it difficult for teachers to provide meaningful feedback that addresses the student's specific strengths and weaknesses.
    
    To address this issue, researchers have proposed the development of an AI-based quiz system that employs Natural Language Processing (NLP) algorithms to examine the text responses offered by students and produce personalized feedback based on their performance. By accepting basic text responses, this system can open up a wider range of options and enable more complex solutions. Additionally, it can dynamically produce questions based on the student's prior responses, increasing its accuracy and efficiency over time.
    The proposed quiz system's uniqueness lies in its adaptive feedback loop. As students’ progress through the quiz, the system can offer increasingly difficult levels of questions based on their performance. This can help students stay motivated and engaged in the learning process, as they are challenged to push themselves further and achieve new levels of mastery.
    
    Ultimately, the goal of this study is to provide students with a dynamic and interesting learning environment that can meet their diverse learning needs and increase their SRL abilities. By leveraging the power of AI and NLP, this quiz system has the potential to revolutionize the way that students learn and teachers provide feedback. If successful, it could pave the way for a new era of personalized education that empowers students to take control of their own learning journey.

 
* **<h3>Other necessary information</h3>**
